<?php
/**
 * Plugin Name: Mottahed-Co Data Tables
 * Plugin URI:  https://mahdimohebi.ir/my-plugins/
 * Description: [mmmdt_all_data]
 * Version:     1.1.3
 * Author:      Madi Mohebi
 * Author URI:  https://mahdimohebi.ir/
 * License:     GPLv2 or later
 * License URI: http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 * Text Domain: mmmdt
 * Domain Path: /languages
 *  
 */
//Mottahed-Co Data Tables
//Mottahed-Co Data Tables
//mmmdt
//hm_gr

/*
توضیحات شرت کات

اگر شرت کات در چنین آدرسی قرار بگیرد
https://mottahedco.ir/person/
اسکریپت جی اسی که همراه با شرت کات چاپ می شود به صورت خودکار دایرکتوری جاری را استخراج می کند
که در اینجا 
person 
است
و سپس آن را در یک متغیر به یو آر ال درخواست ای جکس اضافه می  کند و به سرور می دهد
سرور چک می کند که آیا پارامت کتگوری در درخواست گت وجود دارد یا خیر

اگر وجو نداشته باشد که کل پست ها را بر می گرداند
و اگر وجود داشته باشد کتگوری رو به  کوئری اضافه می کند


*/

if ( ! defined( 'ABSPATH' ) ) {
	die( 'Invalid request.' );
}
define("mmmdt_url", plugin_dir_url(__FILE__));
function mmmdt_load_textdomain() {
  load_plugin_textdomain( 'mmmdt', false, basename( dirname( __FILE__ ) ) . '/languages' ); 
} 
add_action( 'plugins_loaded', 'mmmdt_load_textdomain' );
if ( ! class_exists( 'mmmdt' ) ) {
	class mmmdt {
		private static $settings;
		private function __construct() {
		} 
		public static function init_actions() {
			$plugin_data = get_file_data(__FILE__, [
				'Version' => 'Version',
				'TextDomain' => 'Text Domain'
			], 'plugin');
			define("mmmdt_version",$plugin_data['Version']); 
			register_activation_hook( __FILE__, array( __CLASS__, 'activate' ) );
			register_deactivation_hook(__FILE__, array( __CLASS__, 'deactivat'));
			register_uninstall_hook( __FILE__, array( __CLASS__, 'uninstall' ) );
			add_shortcode('mmmdt_all_data', array( __CLASS__ , 'echo_shortcode_mmmdt_all_data'));
			add_action( 'admin_menu', array( __CLASS__ , 'add_admin_menu' ) );
			add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), array( __CLASS__, 'add_settings_link' ), 10, 2 );
			add_action( 'rest_api_init', array( __CLASS__,'register_route') );
		}
		public static function handel_ajax(){
			if(isset($_POST) and isset($_POST['action']) and $_POST['action']='mmmdt_ajax'  ){
				if(isset($_POST['ajax_type']) and $_POST['ajax_type']=='mmmdt_add_new_car_to_db'  ){
				}elseif(isset($_POST['ajax_type']) and $_POST['ajax_type']=='submit_rahvar_form'){
				}
			}else{
			}
		}
		public static function register_route(){
			// /wp-json/mmmdt/get_all_records
			register_rest_route( 'mmmdt', 'get_all_records', array(
				'methods' => 'GET',
				'callback' => array( __CLASS__, 'get_all_records_fun' ),
				'args' => array(
						'id' => array( 
							'validate_callback' => function( $param, $request, $key ) {
								//return is_numeric( $param );
								return true;
							}
						),
					),
				'permission_callback' => function() {
					//return current_user_can( 'publish_posts' );
					return true;
				}, 
			));
		}	
		public static function get_all_records_fun() {
			//$_GET
			if (isset($_GET['cat']) and !empty($_GET['cat'])){
				$results = get_posts(array(
				   'post_type' => 'post',
				   'numberposts'=> '-1',
				   'category_name' => $_GET['cat'],
				));
			}else{
				$results = get_posts(array(
				   'post_type' => 'post',
				   'numberposts'=> '-1',
				));
			}
			
			
			$data = array();
			$options = array();
			$files = array();
			
			if(!empty($results)){
				foreach($results as $index => $p_obj){
					$obj = new stdClass();
					$obj->id = $p_obj->ID;
					//
					$obj->title = '<a href="'. get_permalink($p_obj->ID) .'" target="_blank">'. $p_obj->post_title .'</a>'; 
					//
					$types = get_the_terms( $p_obj->ID, 'type' );
					$type = array_pop($types);
					$obj->type =  $type->name;
					//
					$vaziayatha = get_the_terms( $p_obj->ID, 'vaziayat' );
					$vaziayat = array_pop($vaziayatha);
					$obj->vaziayat =  $vaziayat->name;
					//
					$categoreis = get_the_terms( $p_obj->ID, 'category' );
					$category = array_pop($categoreis);
					$obj->category =  $category->name;
					//
					$contact = '';
					if( have_rows('p_contact',$p_obj->ID) ){
						$contact .= '<ul class="p_repeater_ul">';
						// loop through the rows of data
						while ( have_rows('p_contact' , $p_obj->ID) ) { 
							the_row();
							// display a sub field value
							$contact .=  '<li class="p_repeater_row">';
							$contact .=  '<span class="p_repeater_title">';
							$contact .=  get_sub_field('title');
							$contact .=  ' </span>';
							$contact .=  '<span class="p_repeater_value_seperator"> : </span>';
							$contact .=  '<span class="p_repeater_title value number">';
							$contact .=  get_sub_field('value');
							$contact .=  ' </span>';
							$contact .=  '</li>';
						}
						$contact .=  '</ul>';
					}else{
						$contact =  ' x ';
					}
					$obj->contact = $contact;
					//
					$relation = '';
					if( have_rows('person_company_repeater',$p_obj->ID) ){
						$relation .= '<ul class="p_repeater_ul">';
						// loop through the rows of data
						while ( have_rows('person_company_repeater' , $p_obj->ID) ) { 
							the_row();
							$relation .= '<li class="p_repeater_row">';
							$relation .= '<span class="p_repeater_title"> ';
							$relation .= get_sub_field('title');
							$relation .= '</span>';
							$relation .= '<span class="p_repeater_value_seperator"> : </span>';
							$relation .= '<span class="p_repeater_title">';
							$relationship_posts = get_sub_field('place');
							if ($relationship_posts){
								foreach ($relationship_posts as $post_id){
									$relation .= '<a href="'. get_permalink($post_id).'" target="_blank">'. get_the_title($post_id) .' </a>';
									if( have_rows('p_contact' ,$post_id )){
										$relation .= '<ul class="p_repeater_ul_ertbat">';
										// loop through the rows of data
										while ( have_rows('p_contact' ,$post_id)) { 
											the_row();
											// display a sub field value
											$relation .= '<li class="p_repeater_row">';
											if (get_sub_field('title')) {
												//echo '<span class="p_repeater_row"> - ';
												$relation .= '<span class="p_repeater_title">';
												$relation .= get_sub_field('title');
												$relation .= '</span>';
											}
											if (get_sub_field('value')) {
												$relation .= '<span class="p_repeater_value_seperator"> : </span>';
												$relation .= '<span class="p_repeater_title value number">';
												$relation .= get_sub_field('value');
												$relation .= ' </span>';
											}
											$relation .= '</li>';
										}
										$relation .= '</ul>';
									}
								}
							}
							$relation .= '</span>';
							if (get_sub_field('dakhli')) {
								$relation .= '<span class="p_repeater_value_seperator"> - </span>';
								$relation .= '<span class="p_repeater_sub_lable"> داخلی :  </span>';
								$relation .= '<span class="p_repeater_title value number">';
								$relation .= get_sub_field('dakhli');
								$relation .= '</span>';
							}
							$relation .= '</li>';
						}
						$relation .=  '</ul>';
					}else{
						$relation =  ' x ';
					}
					$obj->relation = $relation;
					//
					$tovlid = '';
					if( have_rows('p_tovlid_repeater',$p_obj->ID) ){
						$tovlid .= '<ul class="p_repeater_ul">';
						// loop through the rows of data
						while ( have_rows('p_tovlid_repeater' , $p_obj->ID) ) { 
							the_row();
							// display a sub field value
							$tovlid .=  '<li class="p_repeater_row">';
							$tovlid .=  '<span class="p_repeater_title">';
							$tovlid .=  get_sub_field('mahsol');
							$tovlid .=  ' </span>';
							if (get_sub_field('mizan_tovlid')) {
								$tovlid .=  '<span class="p_repeater_value_seperator"> به میزان </span>';
								$tovlid .=  '<span class="p_repeater_title value number">';
								$tovlid .=  get_sub_field('mizan_tovlid');
								$tovlid .=  ' </span>';
							}
							$tovlid .=  '</li>';
						}
						$tovlid .=  '</ul>';
					}else{
						$tovlid =  ' x ';
					}
					$obj->tovlid = $tovlid;
					//
					$masraf = '';
					if( have_rows('p_masraf_repeater',$p_obj->ID) ){
						$masraf .= '<ul class="p_repeater_ul">';
						// loop through the rows of data
						while ( have_rows('p_masraf_repeater' , $p_obj->ID) ) { 
							the_row();
							// display a sub field value
							$masraf .=  '<li class="p_repeater_row">';
							$masraf .=  '<span class="p_repeater_title">';
							$masraf .=  get_sub_field('mahsol');
							$masraf .=  ' </span>';
							if (get_sub_field('mizan_tovlid')) {
								$masraf .=  '<span class="p_repeater_value_seperator"> به میزان </span>';
								$masraf .=  '<span class="p_repeater_title value number">';
								$masraf .=  get_sub_field('mizan_tovlid');
								$masraf .=  ' </span>';
							}
							$masraf .=  '</li>';
						}
						$masraf .=  '</ul>';
					}else{
						$masraf =  ' x ';
					}
					$obj->masraf = $masraf;
					//
					$address = '';
					if(get_field('p_ostan' , $p_obj->ID) or get_field('p_shahrestan' , $p_obj->ID) or get_field('p_address' , $p_obj->ID)){
						$address .=   '<div class="wrapper_address">';
						if( get_field('p_ostan' , $p_obj->ID) ){
							$address .= get_field('p_ostan' , $p_obj->ID);
							$address .= ' ';
						}
						if( get_field('p_shahrestan' , $p_obj->ID) ){
							if( get_field('p_ostan' , $p_obj->ID) ){
								$address .=  ' - ';
							}
							$address .= get_field('p_shahrestan' , $p_obj->ID);
						}
						if( get_field('p_address' , $p_obj->ID) ){
							if( get_field('p_shahrestan' , $p_obj->ID) ){
								$address .=  ' - ';
							}
							$address .= get_field('p_address' , $p_obj->ID);
						}
						$address .= '</div>';
					}else{
						$address =  ' x ';
					}
					$obj->address = $address;
					//$value = get_field( "text_field", 123 );
					//$obj->hmct_maker_guid = get_post_meta( $p_obj->ID, 'hmct_maker_guid', true );
					$obj->DT_RowId = 'row_'.$p_obj->ID;
					$data[] = $obj;
					
				}
			}
			
			$to_return = array('data' => $data,'options' => $options,'files' => $files ,'request' => $_GET);
			
			return rest_ensure_response( $to_return );
		}
		
		public static function add_admin_menu() {
			add_menu_page(
				__( 'Mottahed-Co Data Tables Options', 'mmmdt' ),
				__( 'Mottahed-Co Data Tables', 'mmmdt' ),
				'manage_options',
				'mmmdt',
				array(__CLASS__,'options_page'),
				'dashicons-category'
			);
		}
		public static function options_page() { 
		?>
			
			<div id="mmmdt_main_wrapper">
				<div id="mmmdt_main_inner">
				nothing
				</div>	
			</div>	
		<?php
		}
		public static function echo_shortcode_mmmdt_all_data() { 
		?>
			<script type="text/javascript" src="//cdn.datatables.net/1.10.20/js/jquery.dataTables.min.js"></script>
			<link href="//cdn.datatables.net/1.10.20/css/jquery.dataTables.min.css" rel="stylesheet">
 			
			<script type="text/javascript" src="//cdn.datatables.net/responsive/2.2.3/js/dataTables.responsive.min.js"></script>
			<link href="//cdn.datatables.net/responsive/2.2.3/css/responsive.dataTables.min.css" rel="stylesheet">
			
			<script type="text/javascript" src="//cdn.datatables.net/buttons/1.6.0/js/buttons.print.min.js"></script>
			<script type="text/javascript" src="//cdn.datatables.net/buttons/1.6.0/js/dataTables.buttons.min.js"></script>
			<link href="//cdn.datatables.net/buttons/1.6.0/css/buttons.dataTables.min.css" rel="stylesheet">

			<script type="text/javascript" language="javascript" src="//cdn.datatables.net/buttons/1.6.1/js/buttons.flash.min.js"></script>
			<script type="text/javascript" language="javascript" src="//cdnjs.cloudflare.com/ajax/libs/jszip/3.1.3/jszip.min.js"></script>
			<script type="text/javascript" language="javascript" src="//cdn.datatables.net/buttons/1.6.1/js/buttons.html5.min.js"></script>
			
			<script type="text/javascript" src="//cdn.datatables.net/select/1.3.1/js/dataTables.select.min.js"></script>
			<link href="//cdn.datatables.net/select/1.3.1/css/select.dataTables.min.css" rel="stylesheet">
			
			<script>
				<?php 
					$admin_ajax_url =  admin_url( 'admin-ajax.php' );
					echo "mmmdt_admin_ajax_url = '".$admin_ajax_url."';";
					echo "mmmdt_this_site_url = '".get_site_url()."';";//http://www.example.com
					//ایجاد کوکی برای ویریفای شخص حاضر در جاوا اسکریپت
					$mmmdt_authentication = array('nonce' => wp_create_nonce('wp_rest'));
					?>var mmmdt_authentication = <?php echo json_encode($mmmdt_authentication) ?>;<?php
				?>
			</script>
			<script type="text/javascript" src="<?php echo mmmdt_url.'assets/front.js?v='.mmmdt_version; ?>"></script>
			<link href="<?php echo mmmdt_url.'assets/front.css?v='.mmmdt_version; ?>" rel="stylesheet">
			<script>
			</script>
			<div id="mmmdt_main_wrapper">
				<div id="mmmdt_main_inner">
					<div id="mmmdt_loading_ajax_result_table" style="position:absolute;display:none;right:8px;margin-top:22px;" class="lds-dual-ring "></div>
					<div id="mmmdt_result_section"  style="display:none;">
						<div id="mmmdt_selectTriggerFilter"></div>
						<table id="mmmdt_all_data_result_table" class="display cell-border hover " style="">
							<thead>
								<tr>
									<th>آیدی</th>  
									<th>نوع</th> 
									<th>وضعیت</th> 
									<th>دسته</th> 
									<th>عنوان</th>
									<th>اطلاعات تماس</th>
									<th>مرتبط با </th>
									<th>تولید</th>
									<th>مصرف</th>
									<th>آدرس</th>
								</tr>
							</thead>
							<tfoot>
								
							</tfoot>
						</table>
					</div>
				</div>	
			</div>	
		<?php
		}
		public static function ajax_request() {
			self::handel_ajax();
			die();
		}
		private static function get_settings() {
			self::$settings = get_option( 'mmmdt_settings' );
			return self::$settings;
		}
		public static function enqueue_backend() {
			wp_enqueue_script("jquery");
		}
		public static function add_settings_link( $links, $file ) {
			$settings = self::get_settings();
			if ( current_user_can( 'manage_options' ) ) {
				$url = admin_url( 'edit.php?post_type=blocked_ip&page=mmmdt' );
				$links = (array) $links;
				$links[] = sprintf( '<a href="%s">%s</a>', $url, __( 'Settings', 'mmmdt' ) );
			}
			return $links;
		}
		public static function activate() {
			if (! wp_next_scheduled ( 'scheduled_mmmdt_email' )) {
				$settings = self::get_settings();
				wp_schedule_event(time(), $settings['ip_send_report_period'], 'scheduled_mmmdt_email');
			}
			$settings = array(
				'ip_max_allowed_attempts' => get_option( 'ip_max_allowed_attempts','6' ),
				'ip_reset_attempts_after' => get_option( 'ip_reset_attempts_after','23' ),
			);
			//add_option( 'mmmdt_settings', $settings );
		}
		public static function deactivat() {
		}
		public static function uninstall() {
			delete_option( 'mmmdt_settings' );
		}
		 
	}
	add_action( 'plugins_loaded', array( 'mmmdt', 'init_actions' ) );
	register_activation_hook( __FILE__, array( 'mmmdt', 'activate' ) );
	register_deactivation_hook(__FILE__, array( 'mmmdt', 'deactivat'));
}